import { __decorate, __metadata, __values } from 'tslib';
import { ɵɵdefineInjectable, Injectable, Input, Component, NgModule } from '@angular/core';
import { BehaviorSubject } from 'rxjs';
import { NavigationEnd, PRIMARY_OUTLET, ActivatedRoute, Router, RouterModule } from '@angular/router';
import { filter } from 'rxjs/operators';
import { map } from 'rxjs/internal/operators';
import { CommonModule } from '@angular/common';

var Ng7BootstrapBreadcrumbService = /** @class */ (function () {
    function Ng7BootstrapBreadcrumbService() {
        this.breadcrumbLabels = new BehaviorSubject([]);
        this.newBreadcrumb = new BehaviorSubject([]);
    }
    Ng7BootstrapBreadcrumbService.prototype.updateBreadcrumbLabels = function (labels) {
        this.breadcrumbLabels.next(labels);
    };
    Ng7BootstrapBreadcrumbService.prototype.updateBreadcrumb = function (newBreadcrumb) {
        this.newBreadcrumb.next(newBreadcrumb);
    };
    Ng7BootstrapBreadcrumbService.ɵprov = ɵɵdefineInjectable({ factory: function Ng7BootstrapBreadcrumbService_Factory() { return new Ng7BootstrapBreadcrumbService(); }, token: Ng7BootstrapBreadcrumbService, providedIn: "root" });
    Ng7BootstrapBreadcrumbService = __decorate([
        Injectable({
            providedIn: 'root'
        }),
        __metadata("design:paramtypes", [])
    ], Ng7BootstrapBreadcrumbService);
    return Ng7BootstrapBreadcrumbService;
}());

var Ng7BootstrapBreadcrumbComponent = /** @class */ (function () {
    function Ng7BootstrapBreadcrumbComponent(activatedRoute, router, ng7BootstrapBreadcrumbService) {
        this.activatedRoute = activatedRoute;
        this.router = router;
        this.ng7BootstrapBreadcrumbService = ng7BootstrapBreadcrumbService;
        this.breadcrumb = [];
        this.bgColor = '#eee';
        this.fontSize = '18px';
        this.fontColor = '#0275d8';
        this.lastLinkColor = '#000';
        this.symbol = ' / ';
        this.breadCrumbData();
    }
    Ng7BootstrapBreadcrumbComponent.prototype.ngOnInit = function () {
        var _this = this;
        this.ng7BootstrapBreadcrumbService.breadcrumbLabels.subscribe(function (labelData) {
            var _loop_1 = function (label) {
                if (labelData.hasOwnProperty(label)) {
                    _this.breadcrumb.map(function (crumb) {
                        var e_1, _a;
                        var labelParams = crumb.label.match(/[^{{]+(?=\}})/g);
                        if (labelParams) {
                            try {
                                for (var labelParams_1 = (e_1 = void 0, __values(labelParams)), labelParams_1_1 = labelParams_1.next(); !labelParams_1_1.done; labelParams_1_1 = labelParams_1.next()) {
                                    var labelParam = labelParams_1_1.value;
                                    var dynamicData = labelData[label];
                                    if (labelParam === label) {
                                        crumb.label = crumb.label.replace('{{' + labelParam + '}}', dynamicData);
                                    }
                                }
                            }
                            catch (e_1_1) { e_1 = { error: e_1_1 }; }
                            finally {
                                try {
                                    if (labelParams_1_1 && !labelParams_1_1.done && (_a = labelParams_1.return)) _a.call(labelParams_1);
                                }
                                finally { if (e_1) throw e_1.error; }
                            }
                        }
                    });
                }
            };
            for (var label in labelData) {
                _loop_1(label);
            }
        });
        this.ng7BootstrapBreadcrumbService.newBreadcrumb.subscribe(function (breadcrumb) {
            _this.updateData(_this.activatedRoute, breadcrumb);
        });
    };
    Ng7BootstrapBreadcrumbComponent.prototype.breadCrumbData = function () {
        var _this = this;
        this.router.events
            .pipe(filter(function (event) { return event instanceof NavigationEnd; }))
            .pipe(map(function () { return _this.activatedRoute; }))
            .pipe(map(function (route) {
            while (route.firstChild) {
                route = route.firstChild;
            }
            return route;
        }))
            .pipe(filter(function (route) { return route.outlet === PRIMARY_OUTLET; }))
            .subscribe(function (route) {
            _this.params = route.snapshot.params;
            _this.updateData(route, null);
        });
    };
    Ng7BootstrapBreadcrumbComponent.prototype.updateData = function (route, newBreadcrumb) {
        var _this = this;
        if (route.snapshot.data.breadcrumb || newBreadcrumb) {
            var data = route.snapshot.data.breadcrumb ? route.snapshot.data.breadcrumb : newBreadcrumb;
            var breadcrumb = (JSON.parse(JSON.stringify(data)));
            breadcrumb.map(function (crumb) {
                var e_2, _a, e_3, _b;
                var urlChunks = crumb.url.split('/');
                try {
                    for (var urlChunks_1 = __values(urlChunks), urlChunks_1_1 = urlChunks_1.next(); !urlChunks_1_1.done; urlChunks_1_1 = urlChunks_1.next()) {
                        var chunk = urlChunks_1_1.value;
                        if (chunk.includes(':')) {
                            var paramID = chunk.replace(':', '');
                            // const routerParamID = route.snapshot.params[paramID];
                            var routerParamID = _this.params[paramID];
                            crumb.url = crumb.url.replace(":" + paramID, routerParamID);
                        }
                    }
                }
                catch (e_2_1) { e_2 = { error: e_2_1 }; }
                finally {
                    try {
                        if (urlChunks_1_1 && !urlChunks_1_1.done && (_a = urlChunks_1.return)) _a.call(urlChunks_1);
                    }
                    finally { if (e_2) throw e_2.error; }
                }
                var labelParams = crumb.label.match(/[^{{]+(?=\}})/g);
                if (labelParams) {
                    try {
                        for (var labelParams_2 = __values(labelParams), labelParams_2_1 = labelParams_2.next(); !labelParams_2_1.done; labelParams_2_1 = labelParams_2.next()) {
                            var labelParam = labelParams_2_1.value;
                            // const routerParamID = route.snapshot.params[labelParam.trim()];
                            var routerParamID = _this.params[labelParam.trim()];
                            if (routerParamID) {
                                crumb.label = crumb.label.replace('{{' + labelParam + '}}', routerParamID);
                            }
                            else {
                                // crumb.label = crumb.label.replace('{{' + labelParam + '}}', '');
                            }
                        }
                    }
                    catch (e_3_1) { e_3 = { error: e_3_1 }; }
                    finally {
                        try {
                            if (labelParams_2_1 && !labelParams_2_1.done && (_b = labelParams_2.return)) _b.call(labelParams_2);
                        }
                        finally { if (e_3) throw e_3.error; }
                    }
                }
            });
            this.breadcrumb = breadcrumb;
        }
        else {
            this.breadcrumb = [];
        }
    };
    Ng7BootstrapBreadcrumbComponent.ctorParameters = function () { return [
        { type: ActivatedRoute },
        { type: Router },
        { type: Ng7BootstrapBreadcrumbService }
    ]; };
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], Ng7BootstrapBreadcrumbComponent.prototype, "bgColor", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], Ng7BootstrapBreadcrumbComponent.prototype, "fontSize", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], Ng7BootstrapBreadcrumbComponent.prototype, "fontColor", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], Ng7BootstrapBreadcrumbComponent.prototype, "lastLinkColor", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], Ng7BootstrapBreadcrumbComponent.prototype, "symbol", void 0);
    Ng7BootstrapBreadcrumbComponent = __decorate([
        Component({
            // tslint:disable-next-line: component-selector
            selector: 'app-ng7-bootstrap-breadcrumb',
            template: "<nav aria-label=\"breadcrumb\" [ngStyle]=\"{'background-color': bgColor}\">\r\n    <ol class=\"breadcrumb\" *ngIf=\"breadcrumb.length\">\r\n        <ng-container *ngFor=\"let item of breadcrumb; let i = index\">\r\n            <li class=\"breadcrumb-item\" [ngClass]=\"{'active': breadcrumb.length !== i+1}\" [ngStyle]=\"{'font-size': fontSize}\">\r\n                <a *ngIf=\"item?.url\" [routerLink]=\"item?.url\"  [ngStyle]=\"{'color': fontColor}\">{{ item.label }}</a>\r\n                <span *ngIf=\"!item?.url\" [ngStyle]=\"{'color': lastLinkColor}\">{{ item.label }}</span>\r\n            </li>\r\n        </ng-container>\r\n    </ol>\r\n</nav>\r\n",
            styles: [""]
        }),
        __metadata("design:paramtypes", [ActivatedRoute,
            Router,
            Ng7BootstrapBreadcrumbService])
    ], Ng7BootstrapBreadcrumbComponent);
    return Ng7BootstrapBreadcrumbComponent;
}());

var Ng7BootstrapBreadcrumbModule = /** @class */ (function () {
    function Ng7BootstrapBreadcrumbModule() {
    }
    Ng7BootstrapBreadcrumbModule = __decorate([
        NgModule({
            declarations: [Ng7BootstrapBreadcrumbComponent],
            imports: [
                RouterModule,
                CommonModule
            ],
            exports: [Ng7BootstrapBreadcrumbComponent]
        })
    ], Ng7BootstrapBreadcrumbModule);
    return Ng7BootstrapBreadcrumbModule;
}());

/*
 * Public API Surface of ng7-bootstrap-breadcrumb
 */

/**
 * Generated bundle index. Do not edit.
 */

export { Ng7BootstrapBreadcrumbComponent, Ng7BootstrapBreadcrumbModule, Ng7BootstrapBreadcrumbService };
//# sourceMappingURL=ng7-bootstrap-breadcrumb.js.map
